<?php
/**
 * DokuWiki Plugin linkprefix (Renderer Component)
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  Heiko Barth
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
require_once DOKU_INC.'inc/parser/xhtml.php';

class renderer_plugin_linkprefix extends Doku_Renderer_xhtml {

    function getInfo() {
        return confToHash(dirname(__FILE__).'/plugin.info.txt');
    }

    /**
     * Make available as XHTML replacement renderer
     */
    function canRender($format){
        if($format == 'xhtml') return true;
        return false;
    }

    function externallink($url, $name = NULL) {
                if (!$this->getConf('prefix') || $this->getConf('ignore_same_domain') == 1 && strtolower(parse_url($url, PHP_URL_HOST)) == strtolower($_SERVER["HTTP_HOST"])) {
                        parent::externallink($url, $name);
                        return;
                }

                global $conf;

                $name = $this->_getLinkTitle($name, $url, $isImage);

                if ( !$isImage ) {
                        $class='urlextern';
                }
                else {
                        $class='media';
                }

                //prepare for formating
                $link['target'] = $conf['target']['extern'];
                $link['style']  = '';
                $link['pre']    = '';
                $link['suf']    = '';
                $link['more']   = '';
                $link['class']  = $class;
                $link['url']    = $this->getConf('prefix') . urlencode($url);

                $link['name']   = $name;
                $link['title']  = $this->_xmlEntities($url);
                if($conf['relnofollow']) $link['more'] .= ' rel="nofollow"';

                //output formatted
                $this->doc .= $this->_formatLink($link);
	}

        function _resolveInterWiki($shortcut,$reference){
                if (!$this->getConf('prefix')) {
                        parent::_resolveInterWiki($shortcut,$reference);
                        return;
                }
 

               //get interwiki URL
                if ( isset($this->interwiki[$shortcut]) ) {
                    $url = $this->interwiki[$shortcut];
                } else {
                    // Default to Google I'm feeling lucky
                    $url = 'http://www.google.com/search?q={URL}&amp;btnI=lucky';
                    $shortcut = 'go';
                }

                //split into hash and url part
                list($reference,$hash) = explode('#',$reference,2);

                //replace placeholder
                if(preg_match('#\{(URL|NAME|SCHEME|HOST|PORT|PATH|QUERY)\}#',$url)){
                    //use placeholders
                    $url = str_replace('{URL}',rawurlencode($reference),$url);
                    $url = str_replace('{NAME}',$reference,$url);
                    $parsed = parse_url($reference);
                    if(!$parsed['port']) $parsed['port'] = 80;
                    $url = str_replace('{SCHEME}',$parsed['scheme'],$url);
                    $url = str_replace('{HOST}',$parsed['host'],$url);
                    $url = str_replace('{PORT}',$parsed['port'],$url);
                    $url = str_replace('{PATH}',$parsed['path'],$url);
                    $url = str_replace('{QUERY}',$parsed['query'],$url);
                }else{
                    //default
                    $url = $url.rawurlencode($reference);
                }
                if($hash) $url .= '#'.rawurlencode($hash);
                
		if ($this->getConf('ignore_same_domain') == 0 || strtolower(parse_url($url, PHP_URL_HOST)) != strtolower($_SERVER["HTTP_HOST"]))
			$url = $this->getConf('prefix') . urlencode($url);
	
		return $url;
        }
}
